VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "comctl32.ocx"
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmMain 
   Caption         =   "PPT Monitor (PD-2116-051)"
   ClientHeight    =   3345
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   4455
   LinkTopic       =   "Form1"
   ScaleHeight     =   3345
   ScaleWidth      =   4455
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   3840
      Top             =   1200
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   3840
      Top             =   600
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   3840
      Top             =   0
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin ComctlLib.StatusBar sbStatusBar 
      Align           =   2  'Align Bottom
      Height          =   285
      Left            =   0
      TabIndex        =   1
      Top             =   3060
      Width           =   4455
      _ExtentX        =   7858
      _ExtentY        =   503
      SimpleText      =   ""
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   2
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            AutoSize        =   1
            Object.Width           =   4763
            Object.Tag             =   ""
         EndProperty
         BeginProperty Panel2 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            Style           =   5
            TextSave        =   "3:17 PM"
            Object.Tag             =   ""
         EndProperty
      EndProperty
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin MSFlexGridLib.MSFlexGrid Grid1 
      Height          =   2415
      Left            =   120
      TabIndex        =   0
      ToolTipText     =   "Click on a unit to bring up a detailed view. Click on a register name to change all PPTs at once."
      Top             =   120
      Width           =   3015
      _ExtentX        =   5318
      _ExtentY        =   4260
      _Version        =   393216
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExport 
         Caption         =   "&Export PPT Data to CSV File..."
      End
      Begin VB.Menu mnuExportSchedule 
         Caption         =   "Configure Automatic Export Schedule..."
      End
      Begin VB.Menu mnuFileConfig 
         Caption         =   "&Configure PPTs..."
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About PPT Monitor..."
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
' This program was developed on a Win2K system using Visual Basic 6.0 for
' windows. The program source and binaries are distributed under a BSD
' Style License.
'
' Developed By:
' Matthew T. Linehan
' American LED-gible Inc.
' Phone: 614.851.1100
' email: engineering@ledgible.com
'
' Copyright (C) 2011, American LED-Gible Inc. All rights reserved.
' Redistribution and use in source and binary forms, with or without
' modification, are permitted provided that the following conditions are met:
'
' Redistributions of source code must retain the above copyright notice, this
' list of conditions, and the following disclaimer. Redistributions in binary
' form must reproduce the above copyright notice, this list of conditions and
' the following disclaimer in the documentation and/or other materials provided
' with the distribution.
'
' THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
' IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
' ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
' LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
' CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
' INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
' CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
' ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
' POSSIBILITY OF SUCH DAMAGE.
'---------------------------------------------------------------------------
Option Explicit

Public Sub UpdateData(Unit As Integer)
    
    'This function is called by UpdateUnit
    'When updated data is available for a grid line
    Dim RowLen As Integer
    Dim RowStart As Integer
    Dim Text As String
    
    'Get the number of cells per row
    'for calculating the textarray index
    RowLen = Grid1.Cols
    
    'Calculate the TextArray Index for the
    'Start of this row
    RowStart = Unit * RowLen
        
    'update this grid row
    With PPT(Unit)
        Grid1.TextArray(RowStart + 0) = .Name
        Grid1.TextArray(RowStart + 1) = fmt6Digit(.Goal.Value)
        Grid1.TextArray(RowStart + 2) = fmt6Digit(.Actual.Value)
        Grid1.TextArray(RowStart + 3) = fmtHHMMSS(.DownTime.Value)
        Grid1.TextArray(RowStart + 4) = fmt6Digit(.Pace.Value)
        Grid1.TextArray(RowStart + 5) = fmt6Digit(.GScale.Value)
        Grid1.TextArray(RowStart + 6) = fmt6Digit(.AScale.Value)
        Grid1.TextArray(RowStart + 7) = fmt6Digit(.DScale.Value)
        Grid1.TextArray(RowStart + 8) = fmtRunHld(.KHold.Value)
        Grid1.TextArray(RowStart + 9) = fmtRunHld(.LHold.Value)
        Grid1.TextArray(RowStart + 10) = fmtEnbDis(.KDisable.Value)
        Grid1.TextArray(RowStart + 11) = fmtPort(.Port)
        Grid1.TextArray(RowStart + 12) = fmtAddr(.Address)
        Grid1.TextArray(RowStart + 13) = .Status
    End With
                
End Sub

Private Sub Form_Load()
    
    'Restore form to proper position and size
    Me.Left = GetSetting(App.Title, "Settings", "MainLeft", 1000)
    Me.Top = GetSetting(App.Title, "Settings", "MainTop", 1000)
    Me.width = GetSetting(App.Title, "Settings", "MainWidth", 6500)
    Me.height = GetSetting(App.Title, "Settings", "MainHeight", 6500)
    
    'Initialize the grid display style
    Grid1.HighLight = flexHighlightNever            'Turn off cell highlighting
    Grid1.ScrollTrack = True                        'Enable ScrollTracking
    Grid1.Cols = 14                                 'Set Table Width
    Grid1.Rows = 65                                 'Set Table Height
    Grid1.ColWidth(0) = (Grid1.ColWidth(0) * 2)     'Make the Name Column Double Width
    Grid1.ColWidth(10) = (Grid1.ColWidth(10) * 2)   'Make the Status Column Double Width
    Grid1.FillStyle = flexFillRepeat                'settings apply to table selections
    Grid1.Col = 0: Grid1.Row = 0                    'select top left cell
    Grid1.RowSel = Grid1.Rows - 1                   'select all of the first column
    Grid1.ColSel = Grid1.Cols - 1                   'select the entire table
    Grid1.CellAlignment = flexAlignCenterCenter     'Center Text in the Cell
    Grid1.Col = 0: Grid1.Row = 0                    'select top left cell
    Grid1.ColSel = Grid1.Cols - 1                   'select the top row
    Grid1.CellFontBold = True                       'set text to BOLD
    
    'Set the Grid Column Labels Text
    Grid1.TextArray(0) = "PPT Name"
    Grid1.TextArray(1) = "Goal"
    Grid1.TextArray(2) = "Actual"
    Grid1.TextArray(3) = "Downtime"
    Grid1.TextArray(4) = "Pace"
    Grid1.TextArray(5) = "GScale"
    Grid1.TextArray(6) = "AScale"
    Grid1.TextArray(7) = "DScale"
    Grid1.TextArray(8) = "KHold"
    Grid1.TextArray(9) = "LHold"
    Grid1.TextArray(10) = "KDisable"
    Grid1.TextArray(11) = "Port"
    Grid1.TextArray(12) = "Address"
    Grid1.TextArray(13) = "Status"
    
    'put the curssor in the upper left corner
    Grid1.Col = 1
    Grid1.Row = 1
    
    'put a helpfull note in the status bar
    sbStatusBar.Panels(1).Text = "Click on a unit to bring up a detailed view."
    
    'force some data for debugging
    'PPT(1).Port = 1: PPT(1).Address = Asc("1")
    'PPT(2).Port = 1: PPT(2).Address = Asc("2")
    'PPT(3).Port = 1: PPT(3).Address = Asc("3")
    'PPT(4).Port = 1: PPT(4).Address = Asc("4")
    'PPT(5).Port = 1: PPT(5).Address = Asc("5")
    'PPT(6).Port = 1: PPT(6).Address = Asc("6")
    'PPT(7).Port = 1: PPT(7).Address = Asc("7")
    'PPT(8).Port = 1: PPT(8).Address = Asc("8")
    'PPT(9).Port = 1: PPT(9).Address = Asc("9")
    'PPT(10).Port = 1: PPT(10).Address = Asc("A")
    'PPT(11).Port = 1: PPT(11).Address = Asc("B")
    'PPT(12).Port = 1: PPT(12).Address = Asc("C")
    
End Sub


Private Sub Form_Resize()

    'auto resize the flexgrid to fill the form at run time
    'leave room for the Status Bar at the bottom of the form
    Dim Temp As Long
    Grid1.Top = 0
    Grid1.Left = 0
    Grid1.width = frmMain.ScaleWidth
    Temp = frmMain.ScaleHeight - sbStatusBar.height
    If Temp < 1 Then Temp = 1
    Grid1.height = Temp
    
End Sub


Private Sub Form_Unload(Cancel As Integer)
    'Kill everyting and end the program
    Dim i As Integer
     
    'Tell BackgroundFunction to pack it in
    OpState = False
    
    'close all sub forms
    For i = Forms.Count - 1 To 1 Step -1
        Unload Forms(i)
    Next
    
    'Save frmMain position and size
    If Me.WindowState <> vbMinimized Then
        SaveSetting App.Title, "Settings", "MainLeft", Me.Left
        SaveSetting App.Title, "Settings", "MainTop", Me.Top
        SaveSetting App.Title, "Settings", "MainWidth", Me.width
        SaveSetting App.Title, "Settings", "MainHeight", Me.height
    End If
    
End Sub


Private Sub Grid1_Click()
    
    Dim Unit As Integer
    Dim Register As Integer
    
    'Get the Row and Column clicked on
    Unit = Grid1.MouseRow
    Register = Grid1.MouseCol
    
    If (Unit >= 1) Then
        'Use selected a PPT Detailed View, bring it up
        frmDetail.Tag = Unit
        frmDetail.Show
    Else
        'User selected a Register Column Heading
        'Bring up the Global Register Write Dialog
        Select Case Register
            Case 1  'Goal Register
                frmGWriteReg.Tag = "GO"
                frmGWriteReg.Show
            
            Case 2  'Actual Register
                frmGWriteReg.Tag = "AC"
                frmGWriteReg.Show
            
            Case 3  'Downtime Register
                frmGWriteReg.Tag = "DT"
                frmGWriteReg.Show
            
            Case 4  'Pace Register
                frmGWriteReg.Tag = "PA"
                frmGWriteReg.Show
            
            Case 5  'GScale Register
                frmGWriteReg.Tag = "GS"
                frmGWriteReg.Show
            
            Case 6  'AScale Register
                frmGWriteReg.Tag = "AS"
                frmGWriteReg.Show
            
            Case 7  'DScale Register
                frmGWriteReg.Tag = "DS"
                frmGWriteReg.Show
            
            Case 8  'Keyboard Hold Register
                frmGWriteFlag.Tag = "KH"
                frmGWriteFlag.Show
            
            Case 9  'Logic Hold Register
                MsgQueue.Enqueue "Sorry, you can not write to the LHOLD register." & vbCrLf & _
                                 "Logic Hold is controlled by the PPT's HOLD input." & vbCrLf & _
                                 "The logic hold bit is read only!"

            Case 10  'Keyboard Disable Register
                frmGWriteFlag.Tag = "KD"
                frmGWriteFlag.Show
            
        End Select
        
    End If
    
End Sub


Private Sub Grid1_KeyPress(KeyAscii As Integer)

    'filter keypresses in the grid
    If KeyAscii = Asc(vbCr) Then
        KeyAscii = 0
        Call Grid1_Click
    End If

End Sub

Private Sub mnuExportSchedule_Click()

    'bring up the configure export schedule dialog
    frmExportSchedule.Show
    
End Sub

Private Sub mnuFileConfig_Click()

    'brint up the Configure Dialog
    frmConfig.Show
    
End Sub

Private Sub mnuFileExport_Click()
    'open the windows common 'Save As' dialog
    On Error GoTo errhandler
    CommonDialog1.CancelError = True
    CommonDialog1.Filter = "All Files (*.*)|*.*|Comma Seperated Values File (*.csv)|*.csv"
    CommonDialog1.FilterIndex = 2
    CommonDialog1.FileName = GetSetting(App.Title, "Settings", "FileNameCSV", "PPT.csv")
    CommonDialog1.ShowSave

    'User clicked OK, Remember where the user wants this file saved
    SaveSetting App.Title, "Settings", "FileNameCSV", CommonDialog1.FileName
    
    'Export the Data
    Call ExportCSV(CommonDialog1.FileName, Now)
    Exit Sub
    
errhandler:
    'user clicked cancel
    Beep
    Exit Sub
End Sub

Private Sub mnuHelpAbout_Click()
    
    'bring up the About dialog
    frmAbout.Show

End Sub


Private Sub mnuFileExit_Click()
    
    'Make the program terminate
    Unload Me
    
End Sub

Private Sub sbStatusBar_PanelClick(ByVal Panel As ComctlLib.Panel)

    'Toggle the RXBuf HexDump on and off
    If Val(Me.sbStatusBar.Tag) <> 1 Then
        Me.sbStatusBar.Tag = 1
    Else
        Me.sbStatusBar.Tag = 0
        sbStatusBar.Panels(1).Text = "Click on a unit to bing up a detailed view."
    End If
    
End Sub

Private Sub Timer1_Timer()
    'If there are any messages in the Message Queue
    'show them to the user
    If (MsgQueue.Count > 0) Then
        
        'Summon a new messge box to display the message
        Dim frmM As New frmMessage
        frmM.lMessage = MsgQueue.Dequeue
        Beep
        frmM.Show
        
    End If
End Sub
