VERSION 5.00
Begin VB.Form frmDetail 
   Caption         =   "Detail View -"
   ClientHeight    =   7845
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8280
   LinkTopic       =   "Form1"
   ScaleHeight     =   7845
   ScaleWidth      =   8280
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox tLHold 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   2160
      Locked          =   -1  'True
      TabIndex        =   25
      TabStop         =   0   'False
      ToolTipText     =   "The last Logic Hold Flag read from the PPT."
      Top             =   6120
      Width           =   1575
   End
   Begin VB.TextBox tsLHold 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3840
      Locked          =   -1  'True
      TabIndex        =   26
      TabStop         =   0   'False
      ToolTipText     =   "Comunications status for the LHold register."
      Top             =   6120
      Width           =   3255
   End
   Begin VB.CommandButton bLHold 
      Caption         =   "Toggle"
      Height          =   450
      Left            =   7200
      TabIndex        =   27
      ToolTipText     =   "NOTE: The Logic Hold Bit is Read Only!"
      Top             =   6120
      Width           =   975
   End
   Begin VB.TextBox tDScale 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   2160
      Locked          =   -1  'True
      TabIndex        =   19
      TabStop         =   0   'False
      ToolTipText     =   "The last Down Scale read from the PPT."
      Top             =   4920
      Width           =   1575
   End
   Begin VB.TextBox tsDScale 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3840
      Locked          =   -1  'True
      TabIndex        =   20
      TabStop         =   0   'False
      ToolTipText     =   "Comunications status for the DScale register."
      Top             =   4920
      Width           =   3255
   End
   Begin VB.CommandButton bDScale 
      Caption         =   "Change"
      Height          =   450
      Left            =   7200
      TabIndex        =   21
      ToolTipText     =   "Click to change the Down Scaling factor of the PPT."
      Top             =   4920
      Width           =   975
   End
   Begin VB.TextBox tDownTime 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   2160
      Locked          =   -1  'True
      TabIndex        =   7
      TabStop         =   0   'False
      ToolTipText     =   "The last Down Time read from the PPT."
      Top             =   2520
      Width           =   1575
   End
   Begin VB.TextBox tsDownTime 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3840
      Locked          =   -1  'True
      TabIndex        =   8
      TabStop         =   0   'False
      ToolTipText     =   "Comunications status for the Down Time register."
      Top             =   2520
      Width           =   3255
   End
   Begin VB.CommandButton bDownTime 
      Caption         =   "Change"
      Height          =   450
      Left            =   7200
      TabIndex        =   9
      ToolTipText     =   "Click to change the Down Time of the PPT."
      Top             =   2520
      Width           =   975
   End
   Begin VB.CommandButton bOK 
      Cancel          =   -1  'True
      Caption         =   "OK"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   6600
      TabIndex        =   31
      Top             =   7320
      Width           =   1575
   End
   Begin VB.CommandButton bKDisable 
      Caption         =   "Toggle"
      Height          =   450
      Left            =   7200
      TabIndex        =   30
      ToolTipText     =   "Click to Enable/Disable the PPT Keyboard."
      Top             =   6720
      Width           =   975
   End
   Begin VB.CommandButton bKHold 
      Caption         =   "Toggle"
      Height          =   450
      Left            =   7200
      TabIndex        =   24
      ToolTipText     =   "Click to toggle Run / Hold."
      Top             =   5520
      Width           =   975
   End
   Begin VB.CommandButton bAScale 
      Caption         =   "Change"
      Height          =   450
      Left            =   7200
      TabIndex        =   18
      ToolTipText     =   "Click to change the Actual Scaling factor of the PPT."
      Top             =   4320
      Width           =   975
   End
   Begin VB.CommandButton bGScale 
      Caption         =   "Change"
      Height          =   450
      Left            =   7200
      TabIndex        =   15
      ToolTipText     =   "Click to change the Goal Scaling factor of the PPT."
      Top             =   3720
      Width           =   975
   End
   Begin VB.CommandButton bPace 
      Caption         =   "Change"
      Height          =   450
      Left            =   7200
      TabIndex        =   12
      ToolTipText     =   "Click to change the Pace of the PPT."
      Top             =   3120
      Width           =   975
   End
   Begin VB.CommandButton bActual 
      Caption         =   "Change"
      Height          =   450
      Left            =   7200
      TabIndex        =   6
      ToolTipText     =   "Click to change the Actual of the PPT."
      Top             =   1920
      Width           =   975
   End
   Begin VB.CommandButton bGoal 
      Caption         =   "Change"
      Height          =   450
      Left            =   7200
      TabIndex        =   3
      ToolTipText     =   "Click to change the Goal of the PPT."
      Top             =   1320
      Width           =   975
   End
   Begin VB.TextBox tsGoal 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3840
      Locked          =   -1  'True
      TabIndex        =   2
      TabStop         =   0   'False
      ToolTipText     =   "Comunications status for the Goal register."
      Top             =   1320
      Width           =   3255
   End
   Begin VB.TextBox tsActual 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3840
      Locked          =   -1  'True
      TabIndex        =   5
      TabStop         =   0   'False
      ToolTipText     =   "Comunications status for the Actual register."
      Top             =   1920
      Width           =   3255
   End
   Begin VB.TextBox tsPace 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3840
      Locked          =   -1  'True
      TabIndex        =   11
      TabStop         =   0   'False
      ToolTipText     =   "Comunications status for the Pace register."
      Top             =   3120
      Width           =   3255
   End
   Begin VB.TextBox tsGScale 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3840
      Locked          =   -1  'True
      TabIndex        =   14
      TabStop         =   0   'False
      ToolTipText     =   "Comunications status for the GScale register."
      Top             =   3720
      Width           =   3255
   End
   Begin VB.TextBox tsAScale 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3840
      Locked          =   -1  'True
      TabIndex        =   17
      TabStop         =   0   'False
      ToolTipText     =   "Comunications status for the AScale register."
      Top             =   4320
      Width           =   3255
   End
   Begin VB.TextBox tsKHold 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3840
      Locked          =   -1  'True
      TabIndex        =   23
      TabStop         =   0   'False
      ToolTipText     =   "Comunications status for the KHold register."
      Top             =   5520
      Width           =   3255
   End
   Begin VB.TextBox tsKDisable 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3840
      Locked          =   -1  'True
      TabIndex        =   29
      TabStop         =   0   'False
      ToolTipText     =   "Comunications status for the KDisable register."
      Top             =   6720
      Width           =   3255
   End
   Begin VB.TextBox tKDisable 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   2160
      Locked          =   -1  'True
      TabIndex        =   28
      TabStop         =   0   'False
      ToolTipText     =   "The last Keyboard Disable Flag read from the PPT."
      Top             =   6720
      Width           =   1575
   End
   Begin VB.TextBox tKHold 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   2160
      Locked          =   -1  'True
      TabIndex        =   22
      TabStop         =   0   'False
      ToolTipText     =   "The last Keyboard Hold Flag read from the PPT."
      Top             =   5520
      Width           =   1575
   End
   Begin VB.TextBox tAScale 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   2160
      Locked          =   -1  'True
      TabIndex        =   16
      TabStop         =   0   'False
      ToolTipText     =   "The last Actual Scale read from the PPT."
      Top             =   4320
      Width           =   1575
   End
   Begin VB.TextBox tGScale 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   2160
      Locked          =   -1  'True
      TabIndex        =   13
      TabStop         =   0   'False
      ToolTipText     =   "The last Goal Scale read from the PPT."
      Top             =   3720
      Width           =   1575
   End
   Begin VB.TextBox tPace 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   2160
      Locked          =   -1  'True
      TabIndex        =   10
      TabStop         =   0   'False
      ToolTipText     =   "The last Pace read from the PPT."
      Top             =   3120
      Width           =   1575
   End
   Begin VB.TextBox tActual 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   2160
      Locked          =   -1  'True
      TabIndex        =   4
      TabStop         =   0   'False
      ToolTipText     =   "The last Actual read from the PPT."
      Top             =   1920
      Width           =   1575
   End
   Begin VB.TextBox tGoal 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   2160
      Locked          =   -1  'True
      TabIndex        =   1
      TabStop         =   0   'False
      ToolTipText     =   "The last Goal read from the PPT."
      Top             =   1320
      Width           =   1575
   End
   Begin VB.Label lLHold 
      Alignment       =   2  'Center
      Caption         =   "LHold:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   44
      Top             =   6120
      Width           =   1815
   End
   Begin VB.Label lDScale 
      Alignment       =   2  'Center
      Caption         =   "DScale:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   43
      Top             =   4920
      Width           =   1815
   End
   Begin VB.Label lDownTime 
      Alignment       =   2  'Center
      Caption         =   "Downtime:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   42
      Top             =   2520
      Width           =   1815
   End
   Begin VB.Label Label10 
      Alignment       =   2  'Center
      Caption         =   "Register"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   41
      Top             =   720
      Width           =   1815
   End
   Begin VB.Label lTitle 
      Alignment       =   2  'Center
      Caption         =   "Title"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   40
      Top             =   120
      Width           =   7935
   End
   Begin VB.Label Label9 
      Alignment       =   2  'Center
      Caption         =   "Register Status"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3960
      TabIndex        =   39
      Top             =   720
      Width           =   3135
   End
   Begin VB.Label Label8 
      Alignment       =   2  'Center
      Caption         =   "Value"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   2160
      TabIndex        =   38
      Top             =   720
      Width           =   1575
   End
   Begin VB.Label lKDisable 
      Alignment       =   2  'Center
      Caption         =   "KDisable:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   37
      Top             =   6720
      Width           =   1815
   End
   Begin VB.Label lKHold 
      Alignment       =   2  'Center
      Caption         =   "KHold:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   36
      Top             =   5520
      Width           =   1815
   End
   Begin VB.Label lAScale 
      Alignment       =   2  'Center
      Caption         =   "AScale:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   35
      Top             =   4320
      Width           =   1815
   End
   Begin VB.Label lGScale 
      Alignment       =   2  'Center
      Caption         =   "GScale:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   34
      Top             =   3720
      Width           =   1815
   End
   Begin VB.Label lPace 
      Alignment       =   2  'Center
      Caption         =   "Pace:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   33
      Top             =   3120
      Width           =   1815
   End
   Begin VB.Label lActual 
      Alignment       =   2  'Center
      Caption         =   "Actual:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   32
      Top             =   1920
      Width           =   1815
   End
   Begin VB.Label lGoal 
      Alignment       =   2  'Center
      Caption         =   "Goal:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   0
      Top             =   1320
      Width           =   1815
   End
End
Attribute VB_Name = "frmDetail"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
' This program was developed on a Win2K system using Visual Basic 6.0 for
' windows. The program source and binaries are distributed under a BSD
' Style License.
'
' Developed By:
' Matthew T. Linehan
' American LED-gible Inc.
' Phone: 614.851.1100
' email: engineering@ledgible.com
'
' Copyright (C) 2011, American LED-Gible Inc. All rights reserved.
' Redistribution and use in source and binary forms, with or without
' modification, are permitted provided that the following conditions are met:
'
' Redistributions of source code must retain the above copyright notice, this
' list of conditions, and the following disclaimer. Redistributions in binary
' form must reproduce the above copyright notice, this list of conditions and
' the following disclaimer in the documentation and/or other materials provided
' with the distribution.
'
' THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
' IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
' ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
' LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
' CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
' INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
' CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
' ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
' POSSIBILITY OF SUCH DAMAGE.
'---------------------------------------------------------------------------
Option Explicit

Public Sub UpdateData(Unit As Integer)

    'Module1.UpdateUnit() calles this sub to tell us
    'Updated data is available in the PPT() structure
    'for PPT Unit, we may need to redraw ourselves
    If Unit = Me.Tag Then Call UpdateDetailData

End Sub


Private Sub UpdateDetailData()
    
    'Fill out the Detail Form with data
    'from the PPT() Structure
    Dim Text As String
    
    'Update the Window Caption / Title
    Me.Caption = "Detailed View - " + PPT(Me.Tag).Name
    Me.lTitle = Me.Caption
    
    'Update the Numeric Value Fields
    With PPT(Me.Tag)
    
        'Update Goal
        Me.tGoal.Text = fmt6Digit(.Goal.Value)
        Me.tsGoal.Text = .Goal.Status
        
        'Update Actual
        Me.tActual.Text = fmt6Digit(.Actual.Value)
        Me.tsActual.Text = .Actual.Status
        
        'Update DownTime
        Me.tDownTime.Text = fmtHHMMSS(.DownTime.Value)
        Me.tsDownTime = .DownTime.Status
        
        'Update Pace
        Me.tPace.Text = fmt6Digit(.Pace.Value)
        Me.tsPace.Text = .Pace.Status
        
        'Update Goal Scale
        Me.tGScale.Text = fmt6Digit(.GScale.Value)
        Me.tsGScale.Text = .GScale.Status
        
        'Update Actual Scale
        Me.tAScale.Text = fmt6Digit(.AScale.Value)
        Me.tsAScale.Text = .AScale.Status
        
        'Update Down Scale
        Me.tDScale.Text = fmt6Digit(.DScale.Value)
        Me.tsDScale.Text = .DScale.Status
    
        'Update the Keypad Run/Hold Field
        Me.tKHold.Text = fmtRunHld(.KHold.Value)
        Me.tsKHold.Text = .KHold.Status
    
        'Update the Logic Run/Hold Field
        Me.tLHold.Text = fmtRunHld(.LHold.Value)
        Me.tsLHold.Text = .LHold.Status
    
        'Update the Keyboard ENB/DIS field
        Me.tKDisable.Text = fmtEnbDis(.KDisable.Value)
        Me.tsKDisable.Text = .KDisable.Status
        
    End With
    
End Sub

Private Sub bGoal_Click()
    
    'Bring up the dialog for initiating
    'a write to the PPT Goal Register
    frmWriteReg.Tag = Trim(Str(Me.Tag)) + "GO"
    frmWriteReg.Show
    
End Sub


Private Sub bActual_Click()
    
    'Bring up the dialog for initiating
    'a write to the PPT Actual Register
    frmWriteReg.Tag = Trim(Str(Me.Tag)) + "AC"
    frmWriteReg.Show
    
End Sub


Private Sub bDownTime_Click()

    'Bring up the dialog for initiating
    'a write to the PPT DownTime Register
    frmWriteReg.Tag = Trim(Str(Me.Tag)) + "DT"
    frmWriteReg.Show

End Sub


Private Sub bPace_Click()

    'Bring up the dialog for initiating
    'a write to the PPT Pace Register
    frmWriteReg.Tag = Trim(Str(Me.Tag)) + "PA"
    frmWriteReg.Show
    
End Sub


Private Sub bGScale_Click()

    'Bring up the dialog for initiating
    'a write to the PPT Goal Scale Register
    frmWriteReg.Tag = Trim(Str(Me.Tag)) + "GS"
    frmWriteReg.Show
    
End Sub


Private Sub bAScale_Click()

    'Bring up the dialog for initiating
    'a write to the PPT Actual Scale Register
    frmWriteReg.Tag = Trim(Str(Me.Tag)) + "AS"
    frmWriteReg.Show
    
End Sub


Private Sub bDScale_Click()

    'Bring up the dialog for initiating
    'a write to the PPT Actual Scale Register
    frmWriteReg.Tag = Trim(Str(Me.Tag)) + "DS"
    frmWriteReg.Show
    
End Sub


Private Sub bKHold_Click()

    'Issue Command to Toggle the Keypad Hold State
    Dim Unit As Integer
    Unit = Me.Tag
    
    If PPT(Unit).KHold.Value <> 0 Then
        Call PPT(Unit).CmdQueue.Enqueue("WKH0")
    Else
        Call PPT(Unit).CmdQueue.Enqueue("WKH1")
    End If
    
End Sub


Private Sub bLHold_Click()

    'Can't toggle the logic hold bit
    'It's controlled by the HOLD logic input!
    MsgQueue.Enqueue "Sorry, you can not write to the LHOLD register." & vbCrLf & _
                     "Logic Hold is controlled by the PPT's HOLD input." & vbCrLf & _
                     "The logic hold bit is read only!"
End Sub


Private Sub bKDisable_Click()

    'Issue Command to Toggle the Keypad Disable State
    Dim Unit As Integer
    Unit = Me.Tag
    
    If PPT(Unit).KDisable.Value <> 0 Then
        Call PPT(Unit).CmdQueue.Enqueue("WKD0")
    Else
        Call PPT(Unit).CmdQueue.Enqueue("WKD1")
    End If
    
End Sub

Private Sub bOK_Click()
    
    'use is done with the dialog
    Unload Me
    
End Sub


Private Sub Form_Activate()
    
    'Force an update when the form first pops up
    Call UpdateDetailData

End Sub


Private Sub Form_Load()
    
    'Restore form to proper position
    Me.Left = GetSetting(App.Title, "Settings", "DetailLeft", 1000)
    Me.Top = GetSetting(App.Title, "Settings", "DetailTop", 1000)

End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    'Save Form position
    If Me.WindowState <> vbMinimized Then
        SaveSetting App.Title, "Settings", "DetailLeft", Me.Left
        SaveSetting App.Title, "Settings", "DetailTop", Me.Top
    End If

End Sub

